#include "cms.h"
#include "system.h"
#include "WDT.h"
#include "rf297L.h"
#include "timer1.h"
#include "timer2.h"
#include "PWM.h"
#include "key_scan.h"
#include "INT0.h"
#include "ADC.h"
#include "PORTB_interrupt.h"
#include "car.h"
#include "delay.h"

/**********************************************************
@file car.c
@brief ңСĳļ
@author Derek
@version v1.0
@date 2018-7-11 14:55:00
**********************************************************/





/********************************************************* *
* @name car_init
* @brief СʼӦڶСʼʱ
*
* @param none
*
* @return none
*/
void car_init(void)
{
	/**RF**/
	RF_Init();
    RF_Set_RxMode();
	
	/**ѹ**/
	ADC_Init();	//ADCʼ
	
	/**Դ**/
	TRISC = 0x00;
	PORTC = 0x00;
		
	/**PWM**/
	CCPX_Init(PWM_DIV_16,255);//PWM_DIV_1  255

	/****/
	TRISB &= ~(0x30);	//PORTB Set OUT mode
	PORTB &= ~(0x30);
	
	/**жϿ**/
	Enable_Interrupt();	//жϿ
	

}


/********************************************************* *
* @name car_motion
* @brief Сֹͣǰ
*
* @param car_drive - ѡСֹͣǰ˶
*
* @param speed - Сٶȵ
*
* @return none
*/

void car_motion(CAR_DRIVE_e car_drive,unsigned char speed)
{
	
	if(speed > 100)
		return;
		
	switch(car_drive)
	{
		case CAR_STOP:                     //Сֹͣ
			CCP1_set_duty_percent(100);
			CCP2_set_duty_percent(100);
			break;
		
		case CAR_FORWARD:                  //Сǰ
			CCP1_set_duty_percent(100);
			CCP2_set_duty_percent((100 - speed));
			break;
		
		case CAR_BACKWARD:                 //С
			CCP1_set_duty_percent((100 - speed));
			CCP2_set_duty_percent(100);
			break;
		
		default:
			break;
	}
}


/********************************************************* *
* @name car_ctrl
* @brief С
*
* @param car_dirct - Сķ
*
* @return none
*/
void car_ctrl(CAR_DIRCT_e car_dirct)
{
	
	switch(car_dirct)
	{
		case CAR_FRONT:               //С
			PORTB |= 0x30;
			break;
		
		case CAR_RIGHT:               //С
			PORTB |= 0x10;
			PORTB &= ~(0x20); 
			break;
		
		case CAR_LEFT:                //С
			PORTB |= 0x20;
			PORTB &= ~(0x10);
			break;
		
		default:
			break;
	}
}


unsigned char drive_state = CAR_STOP,direction_state = CAR_FRONT;
/********************************************************* *
* @name rf_rx_handle
* @brief RFݴ,Э
*		 [A5 XX(ָ0001) XX(˶) XXƷ̣ XXٶȣ XXΪ00 XX1-5λ A5]пС
*
* @param none - 
*
* @return none
*/
unsigned char rf_rx_handle(void)
{
	static unsigned char g_frame_dropped = 0;  //ʧ֡
	unsigned char rx_data[10];
	unsigned char i;
	
	/**ѹ**/
	ADC_start(CHANNEL_VREF);
	soft_delay_us(13);
	if(ADC_digital_value > 0x3B1)//0X42C  0x762 
	{		
		car_ctrl(CAR_FRONT);
		car_motion(CAR_STOP,0);	
			
		drive_state = CAR_STOP;
		soft_delay_ms(100);
	}
	else if(RF_Read_RxData(rx_data,9) == 1)                      //жRFǷյ
	{
		/**״̬**/
		RF_ClearFIFO();
		RF_ClearStatus();
		
		/**LEDʾRF**/
		//PORTC = ~PORTC; 	
		/*if(PORTC & 0x01)
			PORTC &= ~(0x01);
		else
			PORTC |= 0x01;*/
			
		g_frame_dropped = 0;    //ʧ֡
					
		if(rx_data[0] == 0xA5 && rx_data[7] == 0xA5)        //жϽյǷЭ
		{
						
			/**ǰ˶**/
			if(rx_data[4] > 100)
				rx_data[4] = 100;
			
			if(rx_data[2] == CAR_FORWARD)
			{
				if(drive_state == CAR_BACKWARD)
				{
					car_motion(CAR_STOP,0);
					soft_delay_ms(200);
				}
				car_motion(CAR_FORWARD,rx_data[4]);
				drive_state = CAR_FORWARD;
			}
			else if(rx_data[2] == CAR_BACKWARD)
			{
				if(drive_state == CAR_FORWARD)
				{
					car_motion(CAR_STOP,0);
					soft_delay_ms(200);
				}
				car_motion(CAR_BACKWARD,rx_data[4]);
				drive_state = CAR_BACKWARD;
			}
			else
			{
				car_motion(CAR_STOP,0);
				drive_state = CAR_STOP;
			}
			

			/**˶**/
			for(i = 0;i < 5;i++)
			{
				if(rx_data[3] == CAR_LEFT)
				{
					if(direction_state == CAR_RIGHT)
					{
						car_ctrl(CAR_FRONT);
						soft_delay_ms(100);
					}
					car_ctrl(CAR_LEFT);
					direction_state = CAR_LEFT;
					
				}
				else if(rx_data[3] == CAR_RIGHT)
				{
					if(direction_state == CAR_LEFT)
					{
						car_ctrl(CAR_FRONT);
						soft_delay_ms(100);
					}
					car_ctrl(CAR_RIGHT);
					direction_state = CAR_RIGHT;
				}
				else
				{
					car_ctrl(CAR_FRONT);
					direction_state = CAR_FRONT;
				}	

				soft_delay_ms(1);
				car_ctrl(CAR_FRONT);
				soft_delay_us(10);
			}
			
			if(direction_state == CAR_LEFT)
			{
				car_ctrl(CAR_LEFT);				
			}
			else if(direction_state == CAR_RIGHT)
			{
				car_ctrl(CAR_RIGHT);
			}
			else
			{
				car_ctrl(CAR_FRONT);
			}
//			soft_delay_ms(2);			
		}
        return 1;
				
	}
	else
	{
		if(g_frame_dropped >= 250)
			g_frame_dropped = 0;
		g_frame_dropped++;		
		
		if(g_frame_dropped > 30)
		{
			car_ctrl(CAR_FRONT);
			car_motion(CAR_STOP,0);
			
			drive_state = CAR_STOP;
			direction_state = CAR_FRONT;
		}
		else
		{
			/**˶**/
			for(i = 0;i < 5;i++)
			{
				if(direction_state == CAR_LEFT)
				{
					car_ctrl(CAR_LEFT);				
				}
				else if(direction_state == CAR_RIGHT)
				{
					car_ctrl(CAR_RIGHT);										
				}
				else
				{
					car_ctrl(CAR_FRONT);
				}
				soft_delay_ms(1);
				car_ctrl(CAR_FRONT);
				soft_delay_us(10);
			}
			
			if(direction_state == CAR_LEFT)
			{
				car_ctrl(CAR_LEFT);				
			}
			else if(direction_state == CAR_RIGHT)
			{
				car_ctrl(CAR_RIGHT);
			}
			else
			{
				car_ctrl(CAR_FRONT);
			}
		}	
//		soft_delay_ms(3);     //עʱ

	}	
		
	return 0;                            
	
}