/*******************************************************************************
 * @note      Copyright (C) 2017 Shanghai Panchip Microelectronics Co., Ltd.
 *            All rights reserved.
 *
 * @file      user_remote.c
 * @brief     ңԽ
 *
 * @history - V1.0, 2017-03-08, xiaoguolin, first implementation.
*******************************************************************************/
#include "lib_user_remote.h"
#include "rf297l.h"
#include "string.h"
#include "delay.h"
#include "car.h"
#include "uart.h"

remote_param_t g_remote_param = {0,};

/*******************************************************************************
 * @brief      CHK_SUM
 * @param[in]  p_dat - ָ
 *             len   - ݳ
 * @param[out] 
 * @return     chksumֵ
 * @history  - V1.0, 2017-03-06, xiaoguolin, first implementation.
 ******************************************************************************/
#define remote_chk_sum    math_sum_bytes
#define __RF_REMOTE_INIT_ADDR_BYTE0   0xE7
#define __RF_REMOTE_INIT_ADDR_BYTE1   0xE7
#define __RF_REMOTE_INIT_ADDR_BYTE2   0xE7

/*******************************************************************************
 * @brief      Ƶ
 * @param[in]  
 * @param[out] 
 * @return     
 * @history  - V1.0, 2017-03-08, xiaoguolin, first implementation.
*******************************************************************************/
void remote_hop_freq(void) //__STATIC_INLINE 
{
	static uint8_t freq = 0;
	if(++freq > 3 )
		freq = 0;
	RF_WriteReg(W_REGISTER + RF_CH, g_remote_param.hop_freq_tbl[freq]);
	/*if(++g_remote_param.hop_freq_index >= 4)
	{
		g_remote_param.hop_freq_index = 0;
	}
	//xn297l_set_channel(g_remote_param.hop_freq_tbl[g_remote_param.hop_freq_index]);//xn297l_set_channel
	RF_WriteReg(W_REGISTER + RF_CH, g_remote_param.hop_freq_tbl[g_remote_param.hop_freq_index]);// xn297l_set_channel*/
}

/*******************************************************************************
 * @brief      ңУʧܻص
 * @param[in]  p_dat - ָ
 *             len   - ݳ
 * @param[out] 
 * @return     
 * @history  - V1.0, 2017-03-06, xiaoguolin, first implementation.
 ******************************************************************************/
void remote_chksum_failed_callback(uint8_t* p_dat,uint16_t len)
{
    
}

#define REMOTE_BUFFER_SIZE         9// __RF_REMOTE_PAYLOAD

///*******************************************************************************
// * @brief      ңԽ״̬
// * @param[in]  
// * @param[out] 
// * @return     
// * @history  - V1.0, 2017-03-08, xiaoguolin, first implementation.
// *             V1.0, 2017-03-18, xiaoguolin, 淶Э֡,ʹUID
//*******************************************************************************/
void remote_update_bothway(void)
{
   /* #if __REMOTE_FIRST_LINK_CALIBRATE_ENABLE != __FALSE
        if(!flag_get(FLAG_REMOTE_ALLOW)){
            return;
       }
   #endif*/
    #define REMOTE_BIND_RX_CODE     0x00
    #define REMOTE_BIND_TX_CODE     0x01
    #define REMOTE_BIND_RX_ACK      0x02
    #define REMOTE_NORMAL_RX        0x03
    #define REMOTE_LOST             0x04
    static uint8_t remote_state = REMOTE_BIND_RX_CODE;
    static uint8_t unlink_cnt = 0;
    uint32_t uid;

    uint8_t remote_rt_buf[REMOTE_BUFFER_SIZE];
    
//    if((rf_get_mode()&RF_MODE_DEV_MASK)!=RF_MODE_REMOTE)    /** Remoteģʽֱӷ */
//    {
//        if(flag_get(FLAG_REMOTE_UNLOCK))
//        {
//            flag_set(FLAG_REMOTE_PAUSE);  /** ңͣ־ */
//        }
//        return;
//    }
//    flag_clr(FLAG_REMOTE_PAUSE);          /** ңͣ־ */

    switch(remote_state)
    {
    /** 
     * (ң->ɻ)
     * +--------------+--------------+---------------------+
     * | Frame Header | Rolling Code | Hop Frequency Table |
     * +--------------+--------------+---------------------+
     * |   AA   55    |  XX  XX  XX  |    XX  XX  XX  XX   |
     * +--------------+--------------+---------------------+
     * Rolling Codeң, ңݱʶ
     * Hop Frequency TableΪƵ
     */
    case REMOTE_BIND_RX_CODE:
        if(RF_Read_RxData(remote_rt_buf,REMOTE_BUFFER_SIZE))
        {
            if(remote_rt_buf[0] == 0xAA && remote_rt_buf[1] == 0x55)
           {
               /** ֵƵ 3+4ֽ */
               memcpy(&g_remote_param.rolling_code,remote_rt_buf+2,7);
               
               /** ȡChip ID */
               uid  = 0xFFFF;//FMC_ReadUID(2) + adc_power_voltage(0);
               g_remote_param.chip_id[0] = uid >> 8;
               g_remote_param.chip_id[1] = uid;
               
               /** ңӱ־ */
               //flag_set(FLAG_REMOTE_LINK);
               
               g_remote_param.hop_freq_index = 0xFF;
               g_remote_param.rc_tx_timer = 8;
               
               remote_state = REMOTE_BIND_TX_CODE;
           }
       }
       else
       {
           
       }
       break;
   /** 
    * 뷢(ɻ->ң)
    * +--------------+----------+--------------+--------------+
    * | Frame Header | Chip ID  | Rolling Code | Invalid Data |
    * +--------------+----------+--------------+--------------+
    * |   5A   5A    |  XX  XX  |  XX  XX  XX  |   XX   XX    |
    * +--------------+----------+--------------+--------------+
    * Chip IDǷɻоƬݱʶ
    */
   case REMOTE_BIND_TX_CODE:
       if(g_remote_param.rc_tx_timer != 0)
       {
           if(++g_remote_param.tx_gap_timer >= 2)
           {
               g_remote_param.rc_tx_timer--;
               g_remote_param.tx_gap_timer = 0;
               remote_rt_buf[0] = 0x5A;
               remote_rt_buf[1] = 0x5A;
               remote_rt_buf[2] = g_remote_param.chip_id[0];
               remote_rt_buf[3] = g_remote_param.chip_id[1];
               remote_rt_buf[4] = g_remote_param.rolling_code[0];
               remote_rt_buf[5] = g_remote_param.rolling_code[1];
               remote_rt_buf[6] = g_remote_param.rolling_code[2];
               //rf_set_mode(RF_MODE_REMOTE|RF_MODE_TX);
			   RF_Set_TxMode();
               RF_TxData(remote_rt_buf,REMOTE_BUFFER_SIZE);
           }
       }
       else
       {
           /** ԹΪַ */
           RF_Write_Buff(W_REGISTER + TX_ADDR,g_remote_param.rolling_code,3);
           RF_Write_Buff(W_REGISTER + RX_ADDR_P0,g_remote_param.rolling_code,3);
           RF_Set_RxMode();
           remote_state = REMOTE_BIND_RX_ACK;

           g_remote_param.no_data_times_limit = 20;
           g_remote_param.rc_tx_timer = 100;
       }
       break;
   /**
    * ACK(ң->ɻ)
    * +--------------+--------------+---------+--------------+
    * | Frame Header | Rolling Code | Chip ID | Invalid Data |
    * +--------------+--------------+---------+--------------+
    * |   A5    A5   |  XX  XX  XX  |  XX XX  |    XX  XX    |
    * +--------------+--------------+---------+--------------+
    */
   case REMOTE_BIND_RX_ACK:        /** ACK */
       if(RF_Read_RxData(remote_rt_buf,REMOTE_BUFFER_SIZE))
       {
           if(remote_rt_buf[0] == 0xA5 && remote_rt_buf[1] == 0xA5 &&
              remote_rt_buf[2] == g_remote_param.rolling_code[0] &&
              remote_rt_buf[3] == g_remote_param.rolling_code[1] &&
              remote_rt_buf[4] == g_remote_param.rolling_code[2] &&
              remote_rt_buf[5] == g_remote_param.chip_id[0] &&
              remote_rt_buf[6] == g_remote_param.chip_id[1])
           {
               remote_rt_buf[0] = __RF_REMOTE_INIT_ADDR_BYTE0;
               remote_rt_buf[1] = __RF_REMOTE_INIT_ADDR_BYTE1;
               remote_rt_buf[2] = __RF_REMOTE_INIT_ADDR_BYTE2;
               RF_Write_Buff(W_REGISTER + RX_ADDR_P1,remote_rt_buf,3);
               RF_Write_Buff(W_REGISTER + TX_ADDR,remote_rt_buf,3);
               // flag_set(FLAG_REMOTE_UNLOCK); /** ң־ */
               // #if __REMOTE_FIRST_LINK_CALIBRATE_ENABLE != __FALSE
                   // flag_set(FLAG_REMOTE_HAVE_LINKED);
                   // flag_set(FLAG_AHRS_CALIBRATE);
                   // flag_set(FLAG_ALT_CALIBRATE);
               // #endif //__REMOTE_FIRST_LINK_CALIBRATE_ENABLE != __FALSE
               remote_state = REMOTE_NORMAL_RX;
               // rcdata_clear_status();                            /** ңһЩ״̬ */

           }
           else if(--g_remote_param.no_data_times_limit == 0)
           {
               remote_rt_buf[0] = __RF_REMOTE_INIT_ADDR_BYTE0;
               remote_rt_buf[1] = __RF_REMOTE_INIT_ADDR_BYTE1;
               remote_rt_buf[2] = __RF_REMOTE_INIT_ADDR_BYTE2;
               RF_Write_Buff(W_REGISTER + RX_ADDR_P0,remote_rt_buf,3);
               RF_Write_Buff(W_REGISTER + TX_ADDR,remote_rt_buf,3);
               remote_state = REMOTE_BIND_RX_CODE;
               //flag_clr(FLAG_REMOTE_LINK);   /** ӱ־ */
           }
       }
       else if(--g_remote_param.rc_tx_timer == 0)              /** ʱδɹع״̬ */
       {
           remote_rt_buf[0] = __RF_REMOTE_INIT_ADDR_BYTE0;
           remote_rt_buf[1] = __RF_REMOTE_INIT_ADDR_BYTE1;
           remote_rt_buf[2] = __RF_REMOTE_INIT_ADDR_BYTE2;
           RF_Write_Buff(W_REGISTER + RX_ADDR_P0,remote_rt_buf,3);
           RF_Write_Buff(W_REGISTER + TX_ADDR,remote_rt_buf,3);
           remote_state = REMOTE_BIND_RX_CODE;
           //flag_clr(FLAG_REMOTE_LINK);       /** ӱ־ */
       }
       break;
   case REMOTE_NORMAL_RX:          /**  */
       if(rf_rx_handle())//(RF_GetStatus()&RX_DR_FLAG)//(RF_Read_RxData(remote_rt_buf,REMOTE_BUFFER_SIZE))
	   {
		  
           remote_hop_freq();
		   //RF_WriteReg(W_REGISTER + RF_CH, g_remote_param.hop_freq_tbl[3]);
		   
           // if(!flag_get(FLAG_WIFI_LINK)){
               // if(remote_rt_buf[REMOTE_BUFFER_SIZE-1]==remote_chk_sum(remote_rt_buf,REMOTE_BUFFER_SIZE-1))
               // {
                   // rcdata_update((remote_rcdata_t*)remote_rt_buf);
               // }
               // else
               // {
                   // remote_chksum_failed_callback(remote_rt_buf,REMOTE_BUFFER_SIZE);
               // }
           // }
           g_remote_param.no_data_times_limit = 15;
           g_remote_param.listen_freq_counter = 8;
           unlink_cnt = 0;         /** ʧ */
           //flag_clr(FLAG_REMOTE_UNLINK);
       }
       // else if(--g_remote_param.no_data_times_limit == 0)
       // {
           // g_remote_param.no_data_times_limit = 15;
           // remote_hop_freq();
           // if(--g_remote_param.listen_freq_counter <= 0)
           // {
               // g_remote_param.listen_freq_counter = 8;
               // g_remote_param.rc_tx_timer = 15;
               // g_remote_param.tx_gap_timer = 0;
               ////flag_clr(FLAG_REMOTE_UNLOCK); /** ң־ */
               // remote_state = REMOTE_LOST;
               // if(unlink_cnt < 2){
                   // if(++unlink_cnt > 1){
                       ////rcdata_clear_status();
                       ////flag_set(FLAG_REMOTE_UNLINK);
                   // }
               // }
           // }
       // }
       break;
   /**
    * ʧؽ(ɻ->ң)
    * +--------------+---------+--------------+--------------+
    * | Frame Header | Chip ID | Rolling Code | Invalid Data |
    * +--------------+---------+--------------+--------------+
    * |  55     AA   |  XX XX  |  XX  XX  XX  |   XX    XX   |
    * +--------------+---------+--------------+--------------+
    */
   case REMOTE_LOST:               /** ңʧ */
       if(g_remote_param.rc_tx_timer != 0)
       {
           g_remote_param.tx_gap_timer++;
           if(g_remote_param.tx_gap_timer >= 2)
           {
               g_remote_param.rc_tx_timer--;
               g_remote_param.tx_gap_timer = 0;
               //xn297l_set_channel(__RF_REMOTE_INIT_CHN);
			   RF_WriteReg(W_REGISTER + RF_CH, DEFAULT_CHANNEL);
               remote_rt_buf[0] = 0x55;
               remote_rt_buf[1] = 0xAA;
               remote_rt_buf[2] = g_remote_param.chip_id[0];
               remote_rt_buf[3] = g_remote_param.chip_id[1];
               remote_rt_buf[4] = g_remote_param.rolling_code[0];
               remote_rt_buf[5] = g_remote_param.rolling_code[1];
               remote_rt_buf[6] = g_remote_param.rolling_code[2];
               RF_Set_TxMode();
               RF_TxData(remote_rt_buf,REMOTE_BUFFER_SIZE);
           }
       }
       else
       {
           //xn297l_set_channel(g_remote_param.hop_freq_tbl[1]);
           remote_hop_freq();
           //xn297l_rx_mode();
		   RF_Set_RxMode();
           //flag_set(FLAG_REMOTE_UNLOCK); /** ң־ */
           remote_state = REMOTE_NORMAL_RX;
       }
       break;
   default:
       // flag_clr(FLAG_REMOTE_UNLOCK);     /** ң־ */
       // flag_clr(FLAG_REMOTE_LINK);       /** ңӱ־ */
       remote_state = REMOTE_BIND_RX_CODE;
       break;
   }
   
   //Send_num(1,&remote_state);//debug
}

/*******************************************************************************
 * @brief      ңʧ״̬
 * @param[in]  
 * @param[out] 
 * @return     
 * @history  - V1.0, 2017-04-17, caozhen, first implementation.
*******************************************************************************/
void remote_update(void)
{
    #if __REMOTE_FIRST_LINK_CALIBRATE_ENABLE != __FALSE
        if(!flag_get(FLAG_REMOTE_ALLOW)){
            return;
        }
    #endif
    #define REMOTE_BIND_RX_CODE     0x00
//    #define REMOTE_BIND_TX_CODE     0x01
//    #define REMOTE_BIND_RX_ACK      0x02
    #define REMOTE_NORMAL_RX        0x03
    #define REMOTE_LOST             0x04
    static uint8_t remote_state = REMOTE_BIND_RX_CODE;
    static uint8_t unlink_cnt = 0;
//	uint32_t uid;

    uint8_t remote_rt_buf[REMOTE_BUFFER_SIZE];

    switch(remote_state)
    {
    /** 
     * (ң->ɻ)
     * +--------------+--------------+---------------------+
     * | Frame Header | Rolling Code | Hop Frequency Table |
     * +--------------+--------------+---------------------+
     * |   AA   55    |  XX  XX  XX  |    XX  XX  XX  XX   |
     * +--------------+--------------+---------------------+
     * Rolling Codeң, ңݱʶ
     * Hop Frequency TableΪƵ
     */
    case REMOTE_BIND_RX_CODE:
        if(RF_Read_RxData(remote_rt_buf,REMOTE_BUFFER_SIZE))
        {
            if(remote_rt_buf[0] == 0xAA && remote_rt_buf[1] == 0x55)
            {
                /** ֵƵ 3+4ֽ */
                memcpy(&g_remote_param.rolling_code,remote_rt_buf+2,7);
                RF_Write_Buff(W_REGISTER +RX_ADDR_P0,g_remote_param.rolling_code,3);//xn297l_set_addr
				soft_delay_ms(1);//delay_us(100);				                                          
				g_remote_param.hop_freq_index = 0xFF;			             
                remote_state = REMOTE_NORMAL_RX;
            }
        }
        else
        {
            
        }
        break;
    case REMOTE_NORMAL_RX:          /**  */
		rf_rx_handle();
		//remote_hop_freq();
		break;
	case REMOTE_LOST:               /** ңʧ */
        if(RF_Read_RxData(remote_rt_buf,REMOTE_BUFFER_SIZE))
        {
            remote_hop_freq();
            g_remote_param.no_data_times_limit = 15;
            g_remote_param.listen_freq_counter = 20;
            unlink_cnt = 0;         /** ʧ */
        }
        else if(--g_remote_param.no_data_times_limit == 0)
        {
            g_remote_param.no_data_times_limit = 15;
            remote_hop_freq();
            if(--g_remote_param.listen_freq_counter <= 0)
            {
                g_remote_param.listen_freq_counter = 20;
                g_remote_param.rc_tx_timer = 15;
                g_remote_param.tx_gap_timer = 0;               
                //remote_state = REMOTE_LOST;
                
                if(unlink_cnt < 2){
                    if(++unlink_cnt > 1){
                        
                    }
                }
            }
        }
        break;
    default:
        remote_state = REMOTE_BIND_RX_CODE;
        break;
    }
}

