/*******************************************************************************
 * @note      Copyright (C) 2017 Shanghai Panchip Microelectronics Co., Ltd.
 *            All rights reserved.
 *
 * @file      user_remote.h
 * @brief     ңԽ
 *
 * @history - V1.0, 2017-03-08, xiaoguolin, first implementation.
 * @history - V1.1, 2017-03-24, caozhen, adding altitude holding mode.
*******************************************************************************/
#ifndef __USER_REMOTE_H
#define __USER_REMOTE_H

#ifdef __cplusplus
extern "C"{
#endif

#include "stdint.h"
    
typedef struct
{
    uint8_t chip_id[2];
    uint8_t rolling_code[3];
    uint8_t hop_freq_tbl[4];
    uint8_t hop_freq_index;
    uint8_t no_data_times_limit;
    uint8_t listen_freq_counter;
    uint8_t rc_tx_timer;
    uint8_t tx_gap_timer;
}remote_param_t;

void remote_update(void);
void remote_update_bothway(void);

#ifdef __cplusplus
}
#endif

#endif // __USER_REMOTE_H
