/*******************************************************************************
 * @note      Copyright (C) 2018 Shenzhen Panchip Microelectronics Co., Ltd.
 *            All rights reserved.
 *
 * @file      user_remote.c
 * @brief     ңԽ
 *
 * @history - V1.0, 2018-11-14, YANG, first implementation.
*******************************************************************************/
#include "cms.h"
#include <string.h>
#include "rf_remote.h"
#include "rf297l.h"
#include "car.h"
#include "delay.h"

typedef unsigned char uint8_t;

uint8_t rf_match_addr[5];
uint8_t frequency_channel[3];
uint8_t g_change_channel;
uint8_t g_change_max;


/********************************************************* *
* @name rf_match_init
* @brief RFƥǰʼ
*
* @param none - none
*
* @param none - none
*
* @return none
*/
void rf_match_init(void)
{	
	RF_SetChannel(RF_FREQ);
	RF_WriteReg(W_REGISTER + RX_PW_P0, RF_PAYLOAD);
	RF_WriteReg(W_REGISTER + SETUP_AW,  0x03);// address witdth is 5 bytes 0x03
	
	RF_ClearFIFO();
	RF_ClearStatus();
}


/********************************************************* *
* @name frequency_hopping
* @brief Ƶ
*
* @param none - none
*
* @param none - none
*
* @return none
*/
void frequency_hopping(void)
{
	uint8_t i;
	for(i = 0;i < 3;i++)
	{	
		if(frequency_channel[g_change_channel] != 0)
		{
			RF_set_channel(frequency_channel[g_change_channel]);
			break;
		}
		
		if(g_change_channel < 2)
		{
			g_change_channel++;

		}
		else
		{
			g_change_channel = 0;		
		}
	}

	if(g_change_channel < 2)
	{
		g_change_channel++;

	}
	else
	{
		g_change_channel = 0;		
	}
}


/********************************************************* *
* @name rf_match_control
* @brief 2.4GͿС
*
* @param none - none
*
* @param none - none
*
* @return none
*/
void rf_match_control(void)
{	
    static uint8_t rf_match_state = RF_MATCH_RX;

	uint8_t rf_buf[RF_PAYLOAD];
	uint8_t car_state[] = {0xA5,0x01,0x00,0x00,0x00,0x00,0x00,0xA5,0x00};
	uint8_t i;
	int j;
	
	switch(rf_match_state)
	{
		case RF_MATCH_RX:
			if(RF_Read_RxData(rf_buf,RF_PAYLOAD))
			{
				for(i = 0;i < sizeof(rf_match_addr);i++)
				{
					rf_match_addr[i] = rf_buf[i+2];
				}
				
				RF_Set_TxMode();
				rf_match_state = RF_MATCH_TX;
			}
			break;
			
		case RF_MATCH_TX:
			for(j = 0;j < RF_RESPOND_TIME;j++)
			{
				RF_TxData(car_state,RF_PAYLOAD);
			}
			
			RF_Write_Buff(W_REGISTER + RX_ADDR_P0,rf_match_addr, sizeof(rf_match_addr));
			RF_Set_RxMode();
			rf_match_state = RF_CONTROL_RX;
			break;
			
		case RF_CONTROL_RX:
			 rf_rx_handle();
			break;
		
		default:
			break;
			
	}
	
}


