#include "cms.h"
#include "virtual_timer.h"
#include "timer1.h"
#include "key_scan.h"


static volatile unsigned int Timer1_set_time;

void Timer1_Init(TIMER1_DIVIDER_e TIMER1_DIVIDER);
void Timer1_start(unsigned int T_nums, unsigned char Timer1_ISR_execution_total_time);
void Timer1_stop(void);
void TIMER1_ISR(void);

/**************************************************************************
*ʱԴΪF = Fosc
*Сʱʱ T = (1/F)*TIMER1_DIVIDER
**************************************************************************/
void Timer1_Init(TIMER1_DIVIDER_e TIMER1_DIVIDER)
{
	T1CON = 0x00;	//TMR1GE = 0,Timer1TMR1ON	TMR1CS = 0;ѡڲʱFOSC
	T1CON |= TIMER1_DIVIDER;	//Ƶ	Bit5 Bit4 
	INTCON |= (0x40);	//PEIE = 1;		δεⲿж
	PIE1 |= 0x01;		//TMR1IE = 1;	TMR1ж
}

/*************************************************************************************
*ʵʱ붨ʱʱƫ,ͨTimer1_ISR_execution_total_time
*Timer1_ISR_execution_total_time == Timer1жϲжϺ˳жϺִʱ䣩/TIMER1_DIVIDER,
*ʱʱ == T_nums * T
*T = (1/F)*TIMER1_DIVIDER
*************************************************************************************/
void Timer1_start(unsigned int T_nums, unsigned char Timer1_ISR_execution_total_time)
{
	Timer1_set_time = 0xffff - T_nums + Timer1_ISR_execution_total_time;
	TMR1L = (unsigned char)(Timer1_set_time);
	TMR1H = (unsigned char)(Timer1_set_time>>8);
	PIR1 &= ~(0x01);	// TMR1IF = 0;	
	T1CON |= 0x01;		// TMR1ON = 1;	Start Timer0
}


void Timer1_stop(void)
{
	PIE1 &= ~(0x01);		//TMR1IE = 0;	TMR1ж
	T1CON &= ~(0x01);	//TMR1ON = 0;	ضʱ
}

void TIMER1_ISR(void)
{
	T1CON &= ~(0x01);	//TMR1ON = 0;	ضʱ
	TMR1L = (unsigned char)(Timer1_set_time);
	TMR1H = (unsigned char)(Timer1_set_time>>8);
	//Do something
	key_scan();
	virtual_timer_pro();
	
	///////////////////////////////////////////////////
	PIR1 &= ~(0x01);	// TMR1IF = 0;	
	T1CON |= 0x01;		//TMR1ON = 1;		ʱ
}
