#include "cms.h"
#include "system.h"
#include "WDT.h"
#include "rf297L.h"
#include "timer1.h"
#include "timer2.h"
#include "PWM.h"
#include "key_scan.h"
#include "INT0.h"
#include "ADC.h"
#include "PORTB_interrupt.h"
#include "remote_ctrl.h"
#include "RFdeal.h"


/********************************************************* *
@file remote_ctrl.c
@brief ң  ͨЭĳļ
@author Derek
@version v1.0
@date 20178-7-12 14:47:00
**********************************************************/
unsigned char g_car_speed;


/********************************************************* *
* @name remote_ctrl_init
* @brief ңʼ
*
* @param none C 
* @param none C 
*
* @return none
*/
void remote_ctrl_init(void)
{
	/**RF**/
	RF_Init();//RFʼ
	RF_Set_TxMode();
	
	/**AD**/
    ADC_Init();	//ADCʼ
	TRISB &= ~(0x02);

	Enable_Interrupt();	//жϿ		
}



/********************************************************* *
* @name key_detect
* @brief ңĸǷ
*
* @param none C 
* @param none C 
*
* @return key_value16λÿһλ1һ
*/
unsigned int key_detect(void)
{
	unsigned char i;
	unsigned int min,max;
	unsigned int key_value = 0,adc_compensate = 10,range = 8;
	unsigned int key_adc[16] = {0,0xDA8,0xC92,0XB8D,0,\
	0,0,0x7D2,0,0x616\
	,0,0x463,0,0,0,0};
	unsigned int two_key_adc[4] = {0x885,0x9A6,0x9B3,0xAC2},two_key_value[] = {0x808,0x804,0x208,0x204};
	unsigned int rocker_direction_adc[3] = {0x388,0x7F1,0xDE6};//{0x388,0x7E7,0xDE6};
	unsigned int rocker_speed_adc[3] = {0x8FF,0x7DE,0x650};//{0xE1E,0x81B,0x3D7};
	unsigned int speed_value;
	unsigned int key_2 = 0x02,key_8 = 0x80;
		
	ADC_start(CHANNEL_RB3); 
	soft_delay_ms(1);
	
	/**жϵ**/
	for(i = 0;i < 16;i++)  
	{
		if(key_adc[i] > adc_compensate)
		{
			//key_adc[i] = key_adc[i] - adc_compensate;   //
			min = key_adc[i] - range;
			max = key_adc[i] + range;
			
			if(min < ADC_digital_value && ADC_digital_value < max)
				key_value = 1 << i;
		}
	}
	
	/**ж϶**/
	for(i = 0;i < 4;i++)
	{
		if(two_key_adc[i] > adc_compensate)
		{
			//two_key_adc[i] = two_key_adc[i] - adc_compensate;   //
			min = two_key_adc[i] - range;
			max = two_key_adc[i] + range;
			
			if(min < ADC_digital_value && ADC_digital_value < max)
				key_value = two_key_value[i];
		}
	}
	
	
	/**ҡҼ**/
	ADC_start(CHANNEL_RB2);
	soft_delay_ms(1);
	if(ADC_digital_value < rocker_direction_adc[0])//
		key_value |= (1 << 11);
	if(ADC_digital_value > rocker_direction_adc[2])//
		key_value |= (1 << 9);
	
	
	
	/**ҡ¼**/
	ADC_start(CHANNEL_RB4);
	soft_delay_ms(1);
	if(ADC_digital_value > rocker_speed_adc[0])//
	{
		key_value |= (1 << 3);
		
		//speed_value = ADC_digital_value / 0x100;
		//speed_value = speed_value - 8;
		//g_car_speed = speed_value * 15;
		
		speed_value = ADC_digital_value - rocker_speed_adc[0];
		g_car_speed = speed_value / 0xF;	
	}	
	if(ADC_digital_value < rocker_speed_adc[2])//
	{
		key_value |= (1 << 2);
		
		//speed_value = ADC_digital_value / 0x100;
		//speed_value = 6 - speed_value;
		//g_car_speed = speed_value * 15;
		
		speed_value = rocker_speed_adc[2] - ADC_digital_value;
		g_car_speed = speed_value / 0xE;
	}
	
	/**ٶȵ**/
	if(key_value & key_2) 
	{
		g_car_speed += 20;
		
		if(g_car_speed > 100)
			g_car_speed = 100;
		
		soft_delay_ms(300);
	}
	if(key_value & key_8) 
	{
		if(g_car_speed > 20)
			g_car_speed -= 20;
		else
			g_car_speed = 0;
			
		soft_delay_ms(300);
	}
	                        
	return key_value;	
}

/********************************************************* *
* @name key_rf_tx
* @brief ңİЭ鴦ܣRF͹ָ
* 		 [A5 XX(ָ0001) XX(˶) XXƷ̣ XXٶȣ XXΪ00 XX1-5λ A5]пС
*
* @param none C 
* @param none C 
*
* @return 0:ûзָ  1ָ
*/
unsigned char key_rf_tx(void)
{
	unsigned char car_ctrl[9] = {0,0,0,0,0,0,0,0,0};
	unsigned int key_4 = 0x08,key_3 = 0x04,key_12 = 0x800,key_10 = 0x200; 
	unsigned int key_value;
	
	/****/
	key_value = key_detect();
	if(key_value == 0)		
	{
		return 0;
	}
	
	car_ctrl[0] = 0xA5;                   //Эͷ
	car_ctrl[7] = 0xA5;                   //Эβ
	
	/****/
	if(key_value & key_4)                 //жϰ4ǰ˶
		car_ctrl[2] = CAR_FORWARD;        //CAR_FORWARD  CAR_BACKWARD  CAR_STOP
	if(key_value & key_3)                 //жϰ3˶
		car_ctrl[2] = CAR_BACKWARD;      
	if(key_value & key_12)                //жϰ12˶
		car_ctrl[3] = CAR_RIGHT;          //CAR_RIGHT  CAR_LEFT CAR_FRONT  CAR_FRONT
	if(key_value & key_10)                //жϰ10˶
		car_ctrl[3] = CAR_LEFT;
	
	car_ctrl[4] = g_car_speed;
	//car_ctrl[3] = CAR_FRONT;          //CAR_RIGHT  CAR_LEFT CAR_FRONT  CAR_FRONT
		
	car_ctrl[6] = car_ctrl[1] ^ car_ctrl[2] ^ car_ctrl[3] ^ car_ctrl[4] ^ car_ctrl[5];   //1-5λΪУ
	
	RF_TxData(car_ctrl,9);
	
	return 1;
}

