#include "cms.h"
#include "system.h"
#include "INT0.h"
#include "timer0.h"
#include "timer1.h"
#include "timer2.h"
#include "PWM.h"
#include "PORTB_interrupt.h"
#include "ADC.h"

void system_set_CPU_frequency(CPU_FREQUENCY_e CPU_Frequency);
void clear_interrupt_flag(void);
void system_to_sleep(void);
void Enable_Interrupt(void);
void Disable_Interrupt(void);

void system_set_CPU_frequency(CPU_FREQUENCY_e CPU_Frequency)
{
	OSCCON = CPU_Frequency;
	OSCTUNE = 0X00;
}

void clear_interrupt_flag(void)
{
	PIR1&= ~0x4f;		//bit0==TMR1IF bit1==TMR2IF bit2==CCP1IF bit3==SSPIF bit6==ADIF
	PIR2&= ~0x19;		//bit0==CCP2IF bit3==BCLIF bit4==EEIF
	INTCON&= ~0x07;	//bit0==RBIF bit1==INTF bit2==T0IF
}

void system_to_sleep(void)
{
	asm("sleep");
	asm("nop");
}

void Enable_Interrupt(void)
{
	INTCON |= 0x80;
}

void Disable_Interrupt(void)
{
	INTCON &= ~(0x80);
}

void interrupt ISR(void)
{
	unsigned char intterrupt_flag[3];
	//ȡжϱ־
	intterrupt_flag[0] = PIR1&0x4f;		//bit0==TMR1IF bit1==TMR2IF bit2==CCP1IF bit3==SSPIF bit6==ADIF
	intterrupt_flag[1] = PIR2&0x19;		//bit0==CCP2IF bit3==BCLIF bit4==EEIF
	intterrupt_flag[2] = INTCON&0x07;	//bit0==RBIF bit1==INTF bit2==T0IF
	
	//תжϺ
	if(intterrupt_flag[2] != 0){
		if((intterrupt_flag[2]&0x01) != 0)	{		//RBIF
			PORTB_CHANGE_ISR();
		}else if((intterrupt_flag[2]&0x02) != 0){		//INTF
			INT0_ISR();
		}else{								//T0IF		((intterrupt_flag[2]&0x04) != 0)
			TIMER0_ISR();			
		}
	}else if(intterrupt_flag[1] != 0){
		if((intterrupt_flag[1]&0x01) != 0){		//CCP2IF
//			CCP2_ISR();
		}else if((intterrupt_flag[1]&0x04) != 0){	//BCLIF	߳ͻж
//			BCL_ISR();
		}else{									//EEIF ((intterrupt_flag[1]&0x10) != 0)
//			EEPROM_WRITE_COMPLETED_ISR();
		}
	}else if(intterrupt_flag[0] != 0){
		if((intterrupt_flag[0]&0x01) != 0){		//TMR1IF
			TIMER1_ISR();
		}else if((intterrupt_flag[0]&0x02) != 0){	//TMR2IF
			TIMER2_ISR();
		}else if((intterrupt_flag[0]&0x04) != 0){	//CCP1IF
//			CCP1_ISR();
		}else if((intterrupt_flag[0]&0x08) != 0){	//SSPIF
//			IIC_OR_SPI_ISR();
		}else{			//ADIF	((intterrupt_flag[0]&0x40) != 0)
			ADC_ISR();
		}
	}else{		//WDT
		
	}
}


